Subject: Re: [PATCH v2 00/10] Low-level Ethernet debugging features.

From: Ben Greear <[email-masked]>
Date: Fri, 10 Feb 2012 09:18:59 -0800

On 02/10/2012 05:25 AM, Eric Dumazet wrote:
> Le jeudi 09 février 2012 à 21:42 -0800, Ben Greear a écrit :
>> On 02/09/2012 08:31 PM, Jeff Kirsher wrote:
>>
>>> Thanks Ben!
>>>
>>> I have applied the series of 10 patches to my queue.  I would like to
>>> have our validation team validate the e100, e1000 and e1000e patches
>>> (and in-directly the net patches).
>>
>> Just in case you can generate errored frames other than ones with just
>> bad FCS, I'm curious to know if rx-all logic works with them.
>>
>> I was thinking I might could get at least some NICs to generate Runt frames
>> by sending small pkts and disabling frame padding, but haven't looked into
>> it too hard yet.
>
> I am interested by this, do you know some NICs able to disable frame
> padding ?

It looks like e1000e driver can send frames at down to 32 bytes, which
should be considered a runt.  I think we'd just need to disable any
padding in the software stacks (not sure it's there now or not), and then
twiddle the 'PSP' but in the "Transmit Control Register".

I'm not sure the best way to enable this feature up at user-space level,
but we could piggy-back on the no-fcs socket option and extend that
flag to mean don't pad packets as well.

Or, could add a new sock-opt perhaps.

Thanks,
Ben

-- 
Ben Greear <[email-masked]>
Candela Technologies Inc  http://www.candelatech.com